#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct FilterByExpressionSeriesNode {
    #[serde(rename = "base")]
    base: super::super::super::api::LocalVariableName,
    #[builder(
        default,
        map(
            key(type = super::super::super::api::LocalVariableName),
            value(type = super::NumericSeriesNode)
        )
    )]
    #[serde(
        rename = "inputs",
        skip_serializing_if = "std::collections::BTreeMap::is_empty",
        default
    )]
    inputs: std::collections::BTreeMap<
        super::super::super::api::LocalVariableName,
        super::NumericSeriesNode,
    >,
    #[builder(into)]
    #[serde(rename = "expression")]
    expression: String,
    #[builder(custom(type = super::FillStrategy, convert = Box::new))]
    #[serde(rename = "fillStrategy")]
    fill_strategy: Box<super::FillStrategy>,
}
impl FilterByExpressionSeriesNode {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        base: super::super::super::api::LocalVariableName,
        expression: impl Into<String>,
        fill_strategy: super::FillStrategy,
    ) -> Self {
        Self::builder()
            .base(base)
            .expression(expression)
            .fill_strategy(fill_strategy)
            .build()
    }
    #[inline]
    pub fn base(&self) -> &super::super::super::api::LocalVariableName {
        &self.base
    }
    #[inline]
    pub fn inputs(
        &self,
    ) -> &std::collections::BTreeMap<
        super::super::super::api::LocalVariableName,
        super::NumericSeriesNode,
    > {
        &self.inputs
    }
    #[inline]
    pub fn expression(&self) -> &str {
        &*self.expression
    }
    #[inline]
    pub fn fill_strategy(&self) -> &super::FillStrategy {
        &*self.fill_strategy
    }
}
